#Code 6.9 SSA: matrix decomposition and grouping diagnostics
rm(list=ls(all=TRUE))

#Directories
dir.udf<-as.character("~/Documents/BOLOGNA/Didattica/NLTS/data_preprocessing/UserDefinedFunctions")
dir.data<-as.character("~/Documents/BOLOGNA/Didattica/NLTS/data_preprocessing/data")
dir.results<-as.character("~/Documents/BOLOGNA/Didattica/NLTS/data_preprocessing/results")

#Read in data
setwd(dir.data)
#ts<-read.csv("Mayport.csv");x<-ts$observed
#ts<-read.csv("disease_1924.csv");x<-ts$SF_obs
#ts<-read.csv("frutti_1.csv");x<-ts$Lemon
ts<-read.csv("disease_1924.csv");x<-ts$Measles_obs

#the name NAO after x<-ts$NAO indicates the header of the selected colums

#SSA Decomposition
library(Rssa)
L=as.integer(length(x)/2) #input SSA window length L=(12 month cycle)(30 repetitions)
s<-ssa(x,L,kind="toeplitz-ssa")  #run Rssa

#Run grouping diagnostics to group eigentriplets
  #First visual diagnostic: Eigenspectrum
eigenvalues<-plot(s,numvalues=20,col="black",lwd=2) #plot 1st 20 largest

  #Second visual diagnostic: Eigenvector plots
plot(s,type="vectors",idx=1:10,xlim=c(1,200),col="black",lwd=2)  #plot 1st 10 for 300 periods

  #Third visual diagnositic: Pairwise scatterplots of eigenvectors
plot(s,type="paired",idx=1:9,plot.contrib=FALSE,col="black",lwd=2)  #plot 1st 9 pairs

  #Fourth diagnostic: Weighted correlation matrix
plot(w<-wcor(s,groups=c(1:20)))  #1st 20 eigentriplets
w.corr.res<-wcor(s,groups=c(1:10))  #table for 1st 10 eigentriplets